{- |
   License      : BSD3
   Maintainer   : Takano Akio <aljee@hyper.cx>
   Stability    : experimental

  Boolean for compile-time type-level computations.
-}
module Data.Yesno
  ( YesTag(..)
  , NoTag(..)
  , Yesno(..)
  ) where

data YesTag = YesTag
data NoTag = NoTag

class Yesno b where
  yesnoToBool :: b -> Bool

instance Yesno YesTag where
  yesnoToBool = const True

instance Yesno NoTag where
  yesnoToBool = const False
